From 3257d8ad2a326898acdf83abe021a55c41615d1b Mon Sep 17 00:00:00 2001
From: Cedric Bosdonnat <cbosdonnat@suse.com>
Date: Tue, 8 Dec 2020 14:26:16 +0100
Subject: [PATCH] Opensuse 3000 bigvm backports (#300)
MIME-Version: 1.0
Content-Type: text/plain; charset=UTF-8
Content-Transfer-Encoding: 8bit

* libvirt domain template memory config fixes

Add unit tests for _gen_xml() on the recently added memory parameters.
Also fixes an issue with an optional attribute.

* virt: support host numa tunning capability

* virt: support cpu model and topology

* virt: make context preprocessing more reusable in _gen_xml

Introduce mapping structures in order to help reusing the common patterns
in the virt._gen_xml() context pre processing.

* xmlutil.change_xml properly handle xpath node number

In XPath the node numbers are counted from 1 rather than 0.
Thus /foo/bar[0] is invalid and should be /foo/bar[1].

Since in the change_xml function we are getting the index from python
lists in these cases, we need to offset these.

* virt: support memory_backing

* virt: support cpu tunning and Iothread allocation

* xmlutil.change_xml: properly handle updated return value for removals

When deleting an attribute that doesn't exist in the node we should not
report a change was made.

* virt.update: properly handle nosharepages and locked elements

When updating we shouldn't set the value as text in those elements.
Libvirt seems happy with it, but it forces modifying the VM definition
even if there was no change.

* xmlutil: use a comparison function to update XML

When updating an XML file, we may need to have a more intelligent
comparison of the current and new values. This typically fits for the
case of numeric values that may have a negligible delta.

* virt.update: handle tiny difference in memory values

Libvirt may round the memory values when defining or updating a VM. That
is perfectly fine, but then the value are slightly different from the
ones passed to the virt.update() function or the virt.running state.
In those cases the state would be reapplied even though there is no real
difference with the VM.

In order to handle that case the memory parameters in the virt.update
mapping now have a comparison function that considers the tiny differences
as equal.

This commit also factorizes the creation of the memory entries in the
virt.update() mapping.

* virt.update: factorize the mapping value definition

In the mapping passed to xmlutil.change_xml() in virt.update() there are
a lot of common patterns. Extract these into helper functions. Some of
them are common enough to even be defined in the xmlutil module.

* virt: add kvm-hint-dedicated feature handling

* virt: add clock configuration for guests

* virt: add qemu guest agent channel

For libvirt to be able to communicate with the QEMU Guest Agent if
installed in the guest, a channel named org.qemu.guest_agent.0 is
needed.

Add this channel by default on all newly created KVM virtual machines.

* virt: allow using IO threads on disks

* Remove unneeded VM XML definition fragments in tests

* virt: canonicalize cpuset before comparing

Multiple libvirt cpuset notations can designate the same thing. We need
to expand those notations into an actual cpu list in order to be able to
properly compare.

For instance if the libvirt definition has '0-5,^4', and we have
'0,1,2,3,5' passed to virt.update(), those should not trigger an update
of the définition since they are defining the same thing.

* virt: only live update vcpu max if there is a change

* Fix stop_on_reboot parameter order to ease cherry-picking

* virt: cleanup the consoles and serials support

* py2 fixes

* align on_reboot with upstream

Co-authored-by: gqlo <guoqing_li@pm.me>
Co-authored-by: marina2209 <mm.antropova@gmail.com>
---
 changelog/57880.added                         |    1 +
 changelog/58844.added                         |    1 +
 salt/modules/virt.py                          | 1246 ++++++-
 salt/states/virt.py                           |  341 +-
 salt/templates/virt/libvirt_chardevs.jinja    |   16 +
 salt/templates/virt/libvirt_domain.jinja      |  268 +-
 salt/utils/xmlutil.py                         |   79 +-
 tests/pytests/unit/modules/virt/conftest.py   |  126 +
 .../pytests/unit/modules/virt/test_domain.py  |  334 ++
 tests/pytests/unit/utils/test_xmlutil.py      |   41 +
 tests/unit/modules/test_virt.py               | 2961 +++++++++++++++--
 tests/unit/states/test_virt.py                |   57 +
 12 files changed, 4940 insertions(+), 531 deletions(-)
 create mode 100644 changelog/57880.added
 create mode 100644 changelog/58844.added
 create mode 100644 salt/templates/virt/libvirt_chardevs.jinja

diff --git a/changelog/57880.added b/changelog/57880.added
new file mode 100644
index 0000000000..6fff4295fa
--- /dev/null
+++ b/changelog/57880.added
@@ -0,0 +1 @@
+CPU model, topology and NUMA node tuning
diff --git a/changelog/58844.added b/changelog/58844.added
new file mode 100644
index 0000000000..c8599125d2
--- /dev/null
+++ b/changelog/58844.added
@@ -0,0 +1 @@
+Enhance console and serial support in virt module
